{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bam_readgroup_to_json:685e4954df4d70f89315a256ecfb707a2dd80b9fcf0d8d10918398df938c6a28"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 1,
                    "tmpdirMax": 1,
                    "outdirMin": 1,
                    "outdirMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/INPUT",
                    "type": "File",
                    "format": "#bam_readgroup_to_json.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "--bam_path"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/MODE",
                    "type": "string",
                    "default": "strict",
                    "inputBinding": {
                        "prefix": "--mode"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bam_readgroup_to_json"
            ],
            "id": "#bam_readgroup_to_json.cwl",
            "outputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/OUTPUT",
                    "format": "#bam_readgroup_to_json.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.json",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output.log"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bwa:6f48348ec54042c9bb420ea5e28eea8f62a81c15b44800673bdfece1f379591b"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#readgroup.yml/readgroup_meta",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_meta/CN",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DT",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/FO",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/ID",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/KS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/LB",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PI",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PL",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PM",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PU",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/SM",
                                    "type": "string"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/forward_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/reverse_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/bam",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        }
                    ]
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.thread_count)",
                    "coresMax": "$(inputs.thread_count)",
                    "ramMin": 10000,
                    "ramMax": 10000,
                    "tmpdirMin": "$(Math.ceil(2 * (inputs.fastq.size) / 1048576))",
                    "tmpdirMax": "$(Math.ceil(2 * (inputs.fastq.size) / 1048576))",
                    "outdirMin": "$(Math.ceil(2 * (inputs.fastq.size) / 1048576))",
                    "outdirMax": "$(Math.ceil(2 * (inputs.fastq.size) / 1048576))"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bwa_record_se.cwl/fastq",
                    "type": "File",
                    "format": "#bwa_record_se.cwl/format_2182"
                },
                {
                    "id": "#bwa_record_se.cwl/fasta",
                    "type": "File",
                    "format": "#bwa_record_se.cwl/format_1929",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ]
                },
                {
                    "id": "#bwa_record_se.cwl/readgroup_meta",
                    "type": "#readgroup.yml/readgroup_meta"
                },
                {
                    "id": "#bwa_record_se.cwl/fastqc_json_path",
                    "type": "File",
                    "inputBinding": {
                        "loadContents": true,
                        "valueFrom": "$(null)"
                    }
                },
                {
                    "id": "#bwa_record_se.cwl/samse_maxOcc",
                    "type": "long",
                    "default": 3
                },
                {
                    "id": "#bwa_record_se.cwl/thread_count",
                    "type": "long"
                }
            ],
            "outputs": [
                {
                    "id": "#bwa_record_se.cwl/OUTPUT",
                    "type": "File",
                    "format": "#bwa_record_se.cwl/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.readgroup_meta['ID'] + \".bam\")"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  function to_rg() {\n    var readgroup_str = \"@RG\";\n    var keys = Object.keys(inputs.readgroup_meta).sort();\n    for (var i = 0; i < keys.length; i++) {\n      var key = keys[i];\n      var value = inputs.readgroup_meta[key];\n      if (key.length == 2 && value != null) {\n        readgroup_str = readgroup_str + \"\\\\t\" + key + \":\" + value;\n      }\n    }\n    return readgroup_str\n  }\n\n  function bwa_aln_33(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"aln\", \"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq.path, \">\", \"aln.sai\", \"&&\",\n    \"bwa\", \"samse\", \"-n\", inputs.samse_maxOcc, \"-r\", \"\\\"\" + rg_str + \"\\\"\", inputs.fasta.path, \"aln.sai\", inputs.fastq.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  function bwa_aln_64(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"aln\", \"-I\",\"-t\", inputs.thread_count, inputs.fasta.path, inputs.fastq.path, \">\", \"aln.sai\", \"&&\",\n    \"bwa\", \"samse\", \"-n\", inputs.samse_maxOcc, \"-r\", \"\\\"\" + rg_str + \"\\\"\", inputs.fasta.path, \"aln.sai\", inputs.fastq.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  function bwa_mem(rg_str, outbam) {\n    var cmd = [\n    \"bwa\", \"mem\", \"-t\", inputs.thread_count, \"-T\", \"0\", \"-R\", \"\\\"\" + rg_str + \"\\\"\",\n    inputs.fasta.path, inputs.fastq.path, \"|\",\n    \"samtools\", \"view\", \"-Shb\", \"-o\", outbam, \"-\"\n    ];\n    return cmd.join(' ')\n  }\n\n  var MEM_ALN_CUTOFF = 70;\n  var fastqc_json = JSON.parse(inputs.fastqc_json_path.contents);\n  var readlength = fastqc_json[inputs.fastq.basename][\"Sequence length\"];\n  var encoding = fastqc_json[inputs.fastq.basename][\"Encoding\"];\n  var rg_str = to_rg();\n\n  var outbam = inputs.readgroup_meta['ID'] + \".bam\";\n\n  if (encoding == \"Illumina 1.3\" || encoding == \"Illumina 1.5\") {\n    return bwa_aln_64(rg_str, outbam)\n  } else if (encoding == \"Sanger / Illumina 1.9\") {\n    if (readlength < MEM_ALN_CUTOFF) {\n      return bwa_aln_33(rg_str, outbam)\n    }\n    else {\n      return bwa_mem(rg_str, outbam)\n    }\n  } else {\n    return\n  }\n\n}\n"
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "id": "#bwa_record_se.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc:27ec215ea82bd62a76ec86f9c8a692010cc0c99169e68d2fa0c0052450321f57"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": "$(inputs.threads)",
                    "coresMax": "$(inputs.threads)",
                    "ramMin": 5000,
                    "ramMax": 5000,
                    "tmpdirMin": 50,
                    "tmpdirMax": 50,
                    "outdirMin": 5,
                    "outdirMax": 5
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc.cwl/adapters",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--adapters"
                    }
                },
                {
                    "id": "#fastqc.cwl/casava",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--casava"
                    }
                },
                {
                    "id": "#fastqc.cwl/contaminants",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--contaminants"
                    }
                },
                {
                    "id": "#fastqc.cwl/dir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--dir"
                    }
                },
                {
                    "id": "#fastqc.cwl/extract",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--extract"
                    }
                },
                {
                    "id": "#fastqc.cwl/format",
                    "type": "string",
                    "default": "fastq",
                    "inputBinding": {
                        "prefix": "--format"
                    }
                },
                {
                    "id": "#fastqc.cwl/INPUT",
                    "type": "File",
                    "format": "#fastqc.cwl/format_2182",
                    "inputBinding": {
                        "position": 99
                    }
                },
                {
                    "id": "#fastqc.cwl/kmers",
                    "type": "long",
                    "default": 7,
                    "inputBinding": {
                        "prefix": "--kmers"
                    }
                },
                {
                    "id": "#fastqc.cwl/limits",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--limits"
                    }
                },
                {
                    "id": "#fastqc.cwl/nano",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nano"
                    }
                },
                {
                    "id": "#fastqc.cwl/noextract",
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "--noextract"
                    }
                },
                {
                    "id": "#fastqc.cwl/nofilter",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nofilter"
                    }
                },
                {
                    "id": "#fastqc.cwl/nogroup",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--nogroup"
                    }
                },
                {
                    "id": "#fastqc.cwl/outdir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--outdir"
                    }
                },
                {
                    "id": "#fastqc.cwl/quiet",
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "prefix": "--quiet"
                    }
                },
                {
                    "id": "#fastqc.cwl/threads",
                    "type": "long",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "--threads"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc.cwl/OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*_fastqc.zip"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/FastQC/fastqc"
            ],
            "id": "#fastqc.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc_to_json:0ebd446f08d9eb6ed5b069e9ae53ad822236dc56bb1154f9df0e0c22b5724ae7"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 1,
                    "tmpdirMax": 1,
                    "outdirMin": 1,
                    "outdirMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc_basicstatistics_json.cwl/sqlite_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--sqlite_path"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc_basicstatistics_json.cwl/OUTPUT",
                    "type": "File",
                    "format": "#fastqc_basicstatistics_json.cwl/format_3464",
                    "outputBinding": {
                        "glob": "fastqc.json"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/fastqc_to_json"
            ],
            "id": "#fastqc_basicstatistics_json.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastqc_db:3383ae9c9beaf905682b21cab14d20b3bc4fc738c7e1e126da99dc288ba016ac"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 100,
                    "tmpdirMax": 100,
                    "outdirMin": 10,
                    "outdirMax": 10
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastqc_db.cwl/INPUT",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--INPUT"
                    }
                },
                {
                    "id": "#fastqc_db.cwl/job_uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--job_uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc_db.cwl/LOG",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".log\")"
                    }
                },
                {
                    "id": "#fastqc_db.cwl/OUTPUT",
                    "type": "File",
                    "format": "#fastqc_db.cwl/format_3621",
                    "outputBinding": {
                        "glob": "$(inputs.INPUT.nameroot + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/fastqc_db"
            ],
            "id": "#fastqc_db.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/merge_sqlite:1b3a6f55be8579ecfb4c9c0513c3b710717a8f4cd8e79c88ee8c0f28f604faa3"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(2 * (req_space / 1048576));\n}      \n",
                    "tmpdirMax": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(2 * (req_space / 1048576));\n}      \n",
                    "outdirMin": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(req_space / 1048576);\n}      \n",
                    "outdirMax": "${\nvar req_space = 0;\nfor (var i = 0; i < inputs.source_sqlite.length; i++) {\n    req_space += inputs.source_sqlite[i].size;\n  }\nreturn Math.ceil(req_space / 1048576);\n}\n"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#merge_sqlite.cwl/source_sqlite",
                    "format": "#merge_sqlite.cwl/format_3621",
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "--source_sqlite"
                        }
                    }
                },
                {
                    "id": "#merge_sqlite.cwl/job_uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--job_uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#merge_sqlite.cwl/destination_sqlite",
                    "format": "#merge_sqlite.cwl/format_3621",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".db\")"
                    }
                },
                {
                    "id": "#merge_sqlite.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".log\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/merge_sqlite"
            ],
            "id": "#merge_sqlite.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/readgroup_json_db:d1c36c48491afa45c76c23624ecf69b37b4f276019cb6e168364f564452e5b37"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 1,
                    "tmpdirMax": 1,
                    "outdirMin": 1,
                    "outdirMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#readgroup_json_db.cwl/json_path",
                    "type": "File",
                    "format": "#readgroup_json_db.cwl/format_3464",
                    "inputBinding": {
                        "prefix": "--json_path"
                    }
                },
                {
                    "id": "#readgroup_json_db.cwl/job_uuid",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--job_uuid"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#readgroup_json_db.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid +\".log\")"
                    }
                },
                {
                    "id": "#readgroup_json_db.cwl/output_sqlite",
                    "type": "File",
                    "format": "#readgroup_json_db.cwl/format_3621",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + \".db\")"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/readgroup_json_db"
            ],
            "id": "#readgroup_json_db.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/job_uuid",
                    "type": "string"
                },
                {
                    "id": "#main/reference_sequence",
                    "type": "File",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".fai",
                        ".pac",
                        ".sa",
                        "^.dict"
                    ]
                },
                {
                    "id": "#main/readgroup_fastq_se",
                    "type": "#readgroup.yml/readgroup_fastq_se_file"
                },
                {
                    "id": "#main/thread_count",
                    "type": "long"
                }
            ],
            "outputs": [
                {
                    "id": "#main/bam",
                    "type": "File",
                    "outputSource": "#main/bwa_se/OUTPUT"
                },
                {
                    "id": "#main/sqlite",
                    "type": "File",
                    "outputSource": "#main/merge_sqlite/destination_sqlite"
                }
            ],
            "steps": [
                {
                    "id": "#main/fastqc",
                    "run": "#fastqc.cwl",
                    "in": [
                        {
                            "id": "#main/fastqc/INPUT",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.fastq)"
                        },
                        {
                            "id": "#main/fastqc/threads",
                            "source": "#main/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_db",
                    "run": "#fastqc_db.cwl",
                    "in": [
                        {
                            "id": "#main/fastqc_db/INPUT",
                            "source": "#main/fastqc/OUTPUT"
                        },
                        {
                            "id": "#main/fastqc_db/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_db/LOG"
                        },
                        {
                            "id": "#main/fastqc_db/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/fastqc_basicstats_json",
                    "run": "#fastqc_basicstatistics_json.cwl",
                    "in": [
                        {
                            "id": "#main/fastqc_basicstats_json/sqlite_path",
                            "source": "#main/fastqc_db/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_basicstats_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/bwa_se",
                    "run": "#bwa_record_se.cwl",
                    "in": [
                        {
                            "id": "#main/bwa_se/fasta",
                            "source": "#main/reference_sequence"
                        },
                        {
                            "id": "#main/bwa_se/fastq",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.fastq)"
                        },
                        {
                            "id": "#main/bwa_se/fastqc_json_path",
                            "source": "#main/fastqc_basicstats_json/OUTPUT"
                        },
                        {
                            "id": "#main/bwa_se/readgroup_meta",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.readgroup_meta)"
                        },
                        {
                            "id": "#main/bwa_se/thread_count",
                            "source": "#main/thread_count"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bwa_se/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/bam_readgroup_to_json",
                    "run": "#bam_readgroup_to_json.cwl",
                    "in": [
                        {
                            "id": "#main/bam_readgroup_to_json/INPUT",
                            "source": "#main/bwa_se/OUTPUT"
                        },
                        {
                            "id": "#main/bam_readgroup_to_json/MODE",
                            "valueFrom": "lenient"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bam_readgroup_to_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/readgroup_json_db",
                    "run": "#readgroup_json_db.cwl",
                    "scatter": "#main/readgroup_json_db/json_path",
                    "in": [
                        {
                            "id": "#main/readgroup_json_db/json_path",
                            "source": "#main/bam_readgroup_to_json/OUTPUT"
                        },
                        {
                            "id": "#main/readgroup_json_db/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/readgroup_json_db/log"
                        },
                        {
                            "id": "#main/readgroup_json_db/output_sqlite"
                        }
                    ]
                },
                {
                    "id": "#main/merge_readgroup_json_db",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_readgroup_json_db/source_sqlite",
                            "source": "#main/readgroup_json_db/output_sqlite"
                        },
                        {
                            "id": "#main/merge_readgroup_json_db/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_readgroup_json_db/destination_sqlite"
                        }
                    ]
                },
                {
                    "id": "#main/merge_sqlite",
                    "run": "#merge_sqlite.cwl",
                    "in": [
                        {
                            "id": "#main/merge_sqlite/source_sqlite",
                            "source": [
                                "#main/fastqc_db/OUTPUT",
                                "#main/merge_readgroup_json_db/destination_sqlite"
                            ]
                        },
                        {
                            "id": "#main/merge_sqlite/job_uuid",
                            "source": "#main/job_uuid"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge_sqlite/destination_sqlite"
                        },
                        {
                            "id": "#main/merge_sqlite/log"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
